"use strict";
(function ($) {
    $.view_list_state = function (element, options) {
        let defaults = {
            row_state_template: ""
        };
        let plugin = this;
        plugin.settings = {}
        let $element = $(element);
        plugin.add_new_state = function () {
            $.ajax({
                type: "POST",
                dataType: "json",
                url: wpbookingpro_root_url + wpbookingpro_api_task,
                data: {
                    task: "state.ajax_add_new_state"
                },
                beforeSend: function () {
                    $('body').loadingModal();
                },
                error: function (xhr) {
                    $.alert({
                        title: 'Error',
                        content: 'there are some error please contact admin !',
                    });
                },
                complete: function () {
                    $('body').loadingModal('destroy');
                },
                success: function (response) {
                    response = JSON.parse(response);
                    loadScripts(response);
                    if (response.result === "success") {
                        $wooBooking.getDrawer().find('.drawerEl-content').html(response.data);
                        $('body').append(response.data_script);
                        $wooBooking.getDrawer().find('.toolbar-btn-save').data('task', "state.ajax_save");
                        $wooBooking.getDrawer().drawer('toggle');
                        $element.find('.view-state-form').find('.state-tab a').on('click', function (e) {
                            e.preventDefault();
                            $(this).tab('show');
                            $element.find('.state-tab a').removeClass('active');
                            $(this).addClass('active');
                        });
                    }
                }
            });
        }
        plugin.edit_state = function ($tr) {
            var id = $tr.data('id');
            $.ajax({
                type: "POST",
                dataType: "json",
                url: wpbookingpro_root_url + wpbookingpro_api_task,
                data: {
                    task: "state.ajax_get_item",
                    id: id
                },
                beforeSend: function () {
                    $('body').loadingModal();
                },
                error: function (xhr) {
                    $.alert({
                        title: 'Error',
                        content: 'there are some error please contact admin !',
                    });
                },
                complete: function () {
                    $('body').loadingModal('destroy');
                },
                success: function (response) {
                    response = JSON.parse(response);
                    loadScripts(response);
                    if (response.result === "success") {
                        $wooBooking.getDrawer().find('.drawerEl-content').html(response.data);
                        $('body').append(response.data_script);
                        $wooBooking.getDrawer().find('.toolbar-btn-save').data('task', "state.ajax_save");
                        $wooBooking.getDrawer().find('.toolbar-btn-save').data('main_table', "main-table");
                        let title = id !== 0 ? `Edit state: ${id}` : 'Add new state';
                        $wooBooking.getDrawer().find('h4.title').html(title);
                        $wooBooking.getDrawer().drawer('toggle');
                        $element.find('.view-state-form').find('.state-tab a').on('click', function (e) {
                            e.preventDefault();
                            $(this).tab('show')
                            $element.find('.state-tab a').removeClass('active');
                            $(this).addClass('active');
                        });
                    }
                }
            });
        }
        plugin.init = function () {
            plugin.settings = $.extend({}, defaults, options);
            $element.find('input[type="checkbox"]').iCheck({
                checkboxClass: 'icheckbox_square-red',
                radioClass: 'iradio_square-red',
                increaseArea: '20%'
            });
            $element.find('.btn-add-state').click(function (e) {
                e.preventDefault();
                $wooBooking.getDrawer().drawer('toggle');
            });
            $element.find('.btn-edit-order').click(function (e) {
                e.preventDefault();
                $wooBooking.getDrawer().drawer('toggle');
            });
            $element.find('.pagination-list-state').twbsPagination({
                totalPages: 35,
                visiblePages: 7,
                onPageClick: function (state, page) {
                    $('#page-content').text('Page ' + page);
                }
            });
            $element.find('.btn-add-new').click(function (e) {
                plugin.add_new_state();
            });
            $element.find('.btn-edit-state').live('click', function (e) {
                let $tr = $(this).closest('tr');
                plugin.edit_state($tr);
            });
            $element.find('.checked-all').click(function (e) {
                $('table.list-state').find('.checkbox-item-state').prop('checked', $(this).is(':checked'));
            });
            $('table.list-state').find('.checkbox-item-state').click(function (e) {
                var checkall = true;
                var $all_checkbox = $('table.list-state').find('.checkbox-item-state');
                for (let i = 0; i < $all_checkbox.length; i++) {
                    var $checkbox = $($all_checkbox[i]);
                    if (!$checkbox.is(':checked')) {
                        checkall = false;
                    }
                }
                if (checkall) {
                    $element.find('.checked-all').prop('checked', true);
                } else {
                    $element.find('.checked-all').prop('checked', false);
                }
            });
            let call_back_when_save_success = function (data) {
                var $table_list_state = $('table.list-state');
                var $row = $table_list_state.find(`tr[data-id="${data.id}"]`);
                if ($row.length)
                    $row.find('.name').html(data.name);
                else {
                    $row = $(plugin.settings.row_state_template);
                    $element.find('.list-state.main-table').find('tbody').prepend($row);
                }
            };
            $element.find('.btn-Attendees').click(function (e) {
                var id = $(this).data('id');
                $.ajax({
                    type: "GET",
                    dataType: "json",
                    url: wpbookingpro_root_url + wpbookingpro_api_task,
                    data: {
                        action: "get_data",
                        id: id
                    },
                    success: function (response) {
                        $wooBooking.getDrawer().drawer('toggle');
                        $element.find('.view-state-form').find('.state-tab a').on('click', function (e) {
                            e.preventDefault();
                            $(this).tab('show')
                        })
                    }
                });
            });
            $element.find('.btn-add-new').click(function (e) {
                var id = $(this).data('id');
                $.ajax({
                    type: "GET",
                    dataType: "json",
                    url: wpbookingpro_root_url + wpbookingpro_api_task,
                    data: {
                        action: "get_data",
                        id: id
                    },
                    success: function (response) {
                        $wooBooking.getDrawer().find('.hy-drawer-content').html(response);
                        $wooBooking.getDrawer().drawer('toggle');
                        $element.find('.view-state-form').find('.state-tab a').on('click', function (e) {
                            e.preventDefault();
                            $(this).tab('show')
                        })
                    }
                });
            });
            $element.find('.btn-delete').click(function (e) {
                let list_delete_state_id = [];
                $element.find('.checkbox-item-state:checked').each(function () {
                    list_delete_state_id.push($(this).val());
                });
                if (list_delete_state_id.length === 0) {
                    $.alert({
                        title: 'Error',
                        content: 'Please choose state before delete!'
                    });
                    return false;
                }
                $.confirm({
                    title: 'Confirm',
                    content: 'Are you sure delete this image in gallery ?',
                    buttons: {
                        confirm: function () {
                            $.ajax({
                                type: "POST",
                                dataType: "json",
                                url: wpbookingpro_root_url + wpbookingpro_api_task,
                                data: {
                                    task: "state.ajax_delete",
                                    list_delete_state_id: list_delete_state_id
                                },
                                success: function (response) {
                                    location.reload(true);
                                }
                            });
                        },
                        cancel: function () {
                        }
                    }
                });
            });
            $wooBooking.call_back_when_save_success = function (data, is_new) {
                location.reload(true);
            }
        }
        plugin.example_function = function () {
        }
        plugin.init();
    }
    $.fn.view_list_state = function (options) {
        return this.each(function () {
            if (undefined == $(this).data('view_list_state')) {
                let plugin = new $.view_list_state(this, options);
                $(this).data('view_list_state'
                    , plugin);
            }
        });
    }
})(jQuery);
